﻿Imports System.Text.RegularExpressions
Imports System.IO
Imports Microsoft.VisualBasic
Imports System.Text

Public Class DataLoader

   Public ReadOnly LoadData As Action(Of String, String) = _
      Sub(routeRequest As String, wayData As String)
         Dim id = 0
         With Program.RoutData
            .Layers.Clear()
            .RequestSource.Clear()
            .Routes.Clear()
            Dim read As Func(Of String, String) = AddressOf My.Computer.FileSystem.ReadAllText

            Dim fi = New FileInfo(routeRequest)
            Dim rgx = New Regex("\w+")
            For Each mt As Match In rgx.Matches(read(fi.FullName))
               If Not .Layers.ContainsKey(mt.Value) Then .Layers.Add(mt.Value, New List(Of Address))
               .RequestSource.Add(mt.Value)
            Next

            fi = New FileInfo(wayData)
            rgx = New Regex( _
               "\[(.*?)\]\s*(.*?)\s*->\s*\(([\d,E-]*)\|([\d,E-]*)\)", RegexOptions.IgnoreCase)
            For Each mt As Match In rgx.Matches(read(fi.FullName))
               Dim addr As New Address() With { _
                  .Typ = mt.Groups(1).Value, _
                  .Name = mt.Groups(2).Value, _
                  .Point = New PointF(Single.Parse(mt.Groups(3).Value), Single.Parse(mt.Groups(4).Value)), _
                  .ID = id}
               id += 1
               Dim addresses As List(Of Address) = Nothing
               If .Layers.TryGetValue(addr.Typ, addresses) Then addresses.Add(addr)
            Next

            Dim sl = New List(Of String)
            sl.Add("Für folgende Stationen wurde keine Addresse auf der Landkarte gefunden:")
            For Each kvp In .Layers
               If kvp.Value.Count = 0 Then sl.Add(kvp.Key)
            Next
            If sl.Count > 1 Then MsgBox(Environment.NewLine.Between(sl))
            .Reset()
         End With
      End Sub

End Class
