﻿Public Class LayerReducer

   Public ReadOnly Reduce As Action = _
      Sub()
         Dim data = Program.RoutData
         Dim addressLists = data.Layers.Values
         Dim start = data.Start.Address
         Dim heap = New Heap(Of Address)(False, Function(addr) addr.StartDistance)
         For Each addressList In addressLists
            For Each addr In addressList
               addr.StartDistance = start.Distance(addr)
               If heap.Count < data.AddressLimitPerLayer Then
                  heap.Push(addr)
               Else
                  heap.TryExchange(addr)
               End If
            Next
            addressList.ReplaceBy(heap.Flush)
         Next
      End Sub

End Class
