﻿Public Class RouteFinder

   Private ReadOnly BestHeap As New Heap(Of Way)(False, Function(w0) (w0.Length))
   Private ReadOnly WaightedHeap As New Heap(Of Way)(False, Function(w0) (w0.Length * 8 * w0.Triviality))

   Public FindDone As Action = Sub()
                               End Sub

   Public ReadOnly NextStep As Action =
      Sub()
         Dim data = Program.RoutData
         If data.Request.Count = 0 Then
            MessageBox.Show("Es gibt keine weitere Station mehr anzulaufen!", "Request-Queue empty")
            Return
         End If
         BestHeap.Clear()
         Dim bestLimit = (data.RouteLimit * 2) \ 10
         Dim waightLimit = data.RouteLimit - bestLimit
         Dim layer = data.Layers(data.Request.Dequeue)
         Dim newWays As New List(Of Way)
         Dim ways = data.Routes
         Dim allAddresses As New List(Of Address)
         For Each w In ways
            For Each addr In From stat In w.Stations Select stat.Address
               addr.TouchedBy += 1
               allAddresses.Add(addr)
            Next
         Next
         For Each w In data.Routes
            Dim addr0 = w.Last.Address
            For Each addr As Address In layer
               Dim w0 = w.Clone
               Dim w1 = Way.From(addr, addr0.Distance(addr))
               w0.Last = w1
               With BestHeap
                  If .Count < bestLimit Then
                     .Push(w0)
                     Continue For
                  Else
                     .TryExchange(w0)
                  End If
               End With
               With WaightedHeap
                  If .Count < waightLimit Then
                     .Push(w0)
                  Else
                     .TryExchange(w0)
                  End If
               End With
            Next
         Next
         newWays.AddRange(WaightedHeap.Flush)
         newWays.AddRange(BestHeap.Flush)
         For Each addr In allAddresses
            addr.TouchedBy = 0
         Next
         data.Routes.ReplaceBy(newWays)
      End Sub

   Public ReadOnly FindComplete As Action = _
      Sub()
         Dim sw = Diagnostics.Stopwatch.StartNew
         With Program.RoutData
            While .Request.Count > 0
               NextStep()
            End While
         End With
         Console.WriteLine(sw.Elapsed.ToString)
         FindDone.Invoke()
      End Sub

End Class
