Imports System.IO
Imports System.Text.RegularExpressions
Imports System.Diagnostics

Public Class frmBaerSucht

   Public NextStep As Action
   Public ReduceLayer As Action
   Public LoadData As Action(Of String, String)
   Public FindComplete As Action
   Public SetLimit As Action(Of Integer)

   Public ReadOnly FindDone As Action = Sub() UpdateGui.RunGui(True)

   Private _Pts As PointF()
   Private _Sw As New Stopwatch

   Private UpdateGui As Action(Of Boolean) = _
      Sub(enable As Boolean)
         SizerPanel2.Enabled = enable
         Me.StatusStrip1.Visible = Not enable
         If enable Then Draw()
      End Sub

   Private Sub AnyButton_Clicked(ByVal Sender As Object, ByVal e As EventArgs) _
         Handles btReload.Click, btNextStep.Click, btComputeAll.Click, btReset.Click, btManual.Click
      _Sw.Restart()
      Select Case True
         Case Sender Is btReload
            Import()
         Case Sender Is btComputeAll
            UpdateGui(False)
            FindComplete.RunAsync()
         Case Sender Is btNextStep
            NextStep.Invoke()
            Draw()
         Case Sender Is btManual
            Process.Start("..\..\NoCode\Manual.rtf")
         Case Sender Is btReset
            Program.RoutData.Reset()
            ReduceLayer.Invoke()
            Draw()
      End Select
   End Sub

   Private Sub Draw()
      Dim id = 0
      _Sw.Stop()
      Dim routeInfs As New List(Of RouteInfo)
      For Each way In Program.RoutData.Routes
         Dim routeInf = New RouteInfo With {.ID = id}
         Dim pts As New List(Of PointF)
         For Each w In way.Stations
            Dim wInf = New WayInfo(w)
            routeInf.Ways.Add(wInf)
            pts.Add(w.Address.Point)
         Next
         routeInfs.Add(routeInf)
         id += 1
      Next
      routeInfs.Reverse()
      RouteInfoBindingSource.DataSource = routeInfs
      lbDuration.Text = String.Format("{0:mm:ss,fff}", New Date(_Sw.ElapsedTicks))
   End Sub

   Private Sub Import()
      LoadData.Invoke("..\..\NoCode\RouteRequest.txt", "..\..\NoCode\WayData.txt")
      ReduceLayer.Invoke()
      Dim pts = From layer In Program.RoutData.Layers.Values From addr In layer Select addr.Point
      _Pts = pts.ToArray
      ChartControl1.ReGrow()
      Dim src = From s In Program.RoutData.Request Select New With {.Request = s}
      grdRequest.DataSource = src.ToArray
      UpdateGui(True)
   End Sub

   Private Sub frmBaerSucht_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
      'Me.StartUpAt(ContentAlignment.TopCenter)
      Import()
      txtRouteLimit.DataBindings.Add("Text", Program.RoutData, "RouteLimit")
      txtNodeLimit.DataBindings.Add("Text", Program.RoutData, "AddressLimitPerLayer")
   End Sub

   Private Sub RouteInfoBindingSource_CurrentChanged(ByVal sender As Object, ByVal e As EventArgs) Handles RouteInfoBindingSource.CurrentChanged
      Dim route = DirectCast(RouteInfoBindingSource.Current, RouteInfo)
      If route.Null Then Return
      Dim pts As New List(Of PointF)
      For Each w In route.Ways
         pts.Add(w.Way.Address.Point)
      Next
      If Program.RoutData.Request.Count = 0 Then pts.RemoveAt(pts.Count - 1)
      ChartControl1.ChangePoints(pts, _Pts)
   End Sub

End Class